#ifndef _UDM_DBMS_H
#define _UDM_DBMS_H

/* for stl_info_t */
#include "udm_search_tl.h"

/* Database type */
#define UDM_DB_UNK		0
#define UDM_DB_MSQL		1
#define UDM_DB_MYSQL		2
#define UDM_DB_PGSQL		3
#define UDM_DB_SOLID		4
#define UDM_DB_VIRT		6
#define UDM_DB_IBASE		7
#define UDM_DB_ORACLE8		8
#define UDM_DB_ORACLE7		9
#define UDM_DB_MSSQL		10
#define UDM_DB_SAPDB		11
#define UDM_DB_DB2		12
#define UDM_DB_FILES		100


#define UDM_URL_ACTION_DELETE		1
#define UDM_URL_ACTION_ADD		2
#define UDM_URL_ACTION_SUPDATE		3
#define UDM_URL_ACTION_LUPDATE		4
#define UDM_URL_ACTION_INSWORDS		5
#define UDM_URL_ACTION_INSCWORDS	6
#define UDM_URL_ACTION_DELWORDS		7
#define UDM_URL_ACTION_DELCWORDS	8
#define UDM_URL_ACTION_UPDCLONE		9
#define UDM_URL_ACTION_REGCHILD		10
#define UDM_URL_ACTION_FINDBYURL	11
#define UDM_URL_ACTION_FINDBYMSG	12
#define UDM_URL_ACTION_FINDORIG		13


extern int UdmURLAction(UDM_AGENT * Agent, UDM_DOCUMENT * Doc, int cmd);


/* Other URL related functions */
extern UDM_DOCUMENT * UdmGetDocInfo(UDM_AGENT* Indexer,int expired_first);
extern UDM_RESULT   * UdmCloneList(UDM_AGENT*,		UDM_DOCUMENT * D);


/* Servers and stopwords */
extern int UdmLoadServerTable(UDM_AGENT * Indexer, char * path,int flags);


/* Other FIXME Agent -> db */
extern __INDLIB__ int UdmMarkForReindex(UDM_AGENT * Indexer);


/* DB FIXME, remove Indexer */
extern char * UdmDBErrorMsg(void *db);
extern int    UdmDBErrorCode(void *db);
extern void   UdmSetDBErrorCode(void * db,int code);

extern __INDLIB__ void * UdmAllocDB(UDM_AGENT * Indexer,const char * dbaddr,int mode);
extern __INDLIB__ void   UdmFreeDB(void *);

extern int    UdmClearDB(UDM_AGENT * Indexer);



/* Misc FIXME: replace Indexer with DB */
extern __INDLIB__ int UdmGetReferers(UDM_AGENT * Indexer);
extern __INDLIB__ int UdmGetStatistics(UDM_AGENT * Indexer);
extern __INDLIB__ int UdmGetDocCount(UDM_AGENT * Indexer);
extern __INDLIB__ UDM_URLSTATE * UdmGetURLState(UDM_AGENT * Agent,const char * hostinfo,time_t lmt);



/**************************************************************/
/* FIXME: probably move to other file */
extern UDM_UINT8_URLID* GetPair8FromSQL(UDM_AGENT *Agent,const char *field,int *count,int type);
extern UDM_UINT4_URLID* GetPair4FromSQL(UDM_AGENT *Agent,const char *field,int *count,int type);
/**************************************************************/


/**************************************************************/
/* Limits */
extern __INDLIB__ int UdmAddTagLimit(UDM_ENV * Conf,char * tag);
extern __INDLIB__ int UdmAddStatusLimit(UDM_ENV* Conf,int status);
extern __INDLIB__ int UdmAddURLLimit(UDM_ENV *,char * URL);
extern __INDLIB__ int UdmAddLangLimit(UDM_ENV *,char * lang);
extern __INDLIB__ int UdmAddTimeLimit(UDM_ENV *,struct udm_stl_info_t *stl);
extern __INDLIB__ int UdmAddCatLimit(UDM_ENV *,char * category);
extern __INDLIB__ int UdmAddWeightLimit(UDM_ENV*,int weight_id);
extern __INDLIB__ int UdmClearURLLimit(UDM_ENV*);
extern __INDLIB__ int UdmClearLimits(UDM_ENV*);
/**************************************************************/



/* Categories FIXME: AGENT -> db */
extern UDM_CATEGORY  *  UdmCatPath(UDM_AGENT *,const char * addr);
extern UDM_CATEGORY  *  UdmCatList(UDM_AGENT *,const char * addr);

/* Search */
extern int UdmResAddDocInfo(UDM_AGENT * query, UDM_RESULT * Res);
extern UDM_URL_CRD * UdmFindWords(UDM_AGENT * query, const char * words);
extern UDM_RESULT * UdmFind(UDM_AGENT *,const char * text);

#ifdef USE_HTDB
int UdmHTDBGet(UDM_AGENT * Indexer,char *path,char *filename, char * htdb_list,char * htdb_doc);
#endif




#endif
