#ifndef _UDM_TEMPLATE_H
#define _UDM_TEMPLATE_H


/**************************************************/

#define T_UNKNOWN	 0
#define T_TOP		 1
#define T_BOTTOM	 2
#define T_RESTOP	 3
#define T_RESBOT	 4
#define T_RESULT	 5
#define T_ERROR		 6
#define T_NOTFOUND	 7
#define T_CLONE		 8
#define T_NAVLEFT	 9
#define T_NAVBAR0	10
#define T_NAVBAR1	11
#define T_NAVRIGHT	12
#define T_INCLUDE	13
#define T_NAVLEFT_NOP	14
#define T_NAVRIGHT_NOP	15
#define T_NOQUERY	16
#define T_VARIABLES	17
#define T_MAX		18

#define MAX_FORMAT	10

typedef struct {
	int type;
	const char * begin;
	const char * end;
} TPART;


typedef struct {
	int nformats;
	char * template[MAX_FORMAT];
} TMPL;


extern void UdmTemplateInit(TMPL *t);
extern int  UdmTemplateLoad(UDM_ENV * Env, UDM_VARLIST * vars, const char * tname, TMPL * tmpl);
extern void UdmTemplatePrint(UDM_AGENT * Agent,FILE * stream,char * dst,UDM_VARLIST * vars, TMPL * t, int where);
extern void UdmTemplateFree(TMPL * tmpl);

#endif
