#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <ctype.h>


#include "udm_config.h"
#include "udm_common.h"
#include "udm_db.h"
#include "udm_xmalloc.h"
#include "udm_utils.h"
#include "udm_agent.h"
#include "udm_word.h"
#include "udm_crossword.h"
#include "udm_sdp.h"

__INDLIB__ UDM_AGENT * UdmAllocAgent(UDM_ENV * Env, int handle, int db_open_mode){
	UDM_AGENT * result;
	int i;

	result=(UDM_AGENT*)malloc(sizeof(UDM_AGENT));
	bzero(result,sizeof(*result));

	result->Conf=Env;
	result->handle=handle; /* Handle is used in multi-threaded version */
	result->db=UdmAllocDB(result,Env->DBAddr,db_open_mode);
	
        /* Reserve connection structure */
	result->connp = (UDM_CONN*)UdmXmalloc(sizeof(UDM_CONN));
	result->connp->indexer = result;
	result->connp->connp = (UDM_CONN*)UdmXmalloc(sizeof(UDM_CONN));
	result->connp->connp->indexer = result;
	
	result->word_match=UDM_MATCH_FULL;
	result->sort_order=UDM_ORD_RATE;
	result->page_size=20;
	bzero(&result->t_Spell,sizeof(UDM_SPELL));
	result->read_timeout=UDM_READ_TIMEOUT;
	result->doc_timeout=UDM_DOC_TIMEOUT;
	result->spellang = -1;
	
	for(i=0;i<256;i++)
		result->wf[i]=1;
	
	return(result);
}
__INDLIB__ void UdmFreeAgent(UDM_AGENT *Indexer){

	if(Indexer){
		size_t cl;
		UdmFreeDB(Indexer->db);
		UDM_FREE(Indexer->buf);
		UDM_FREE(Indexer->connp->hostname);
		UDM_FREE(Indexer->connp->connp);
		UDM_FREE(Indexer->connp);
		UDM_FREE(Indexer->glang);
		UdmWideWordListFree(&Indexer->WWList);
		for(cl=0;cl<Indexer->sdcl.nclients;cl++)
			UdmSearchdClose(Indexer,&Indexer->sdcl.Clients[cl]);
		UDM_FREE(Indexer);
	}
}


__INDLIB__ char * UdmAgentErrorMsg(UDM_AGENT *Indexer){
	return(UdmDBErrorMsg(Indexer->db));
}

__INDLIB__ void UdmAgentSetAction(UDM_AGENT *Indexer,int action){
	Indexer->action=action;
}

