#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>

#include "udm_config.h"
#include "udm_common.h"
#include "udm_utils.h"
#include "udm_header.h"


void UdmHeaderFree(UDM_HTTPHEADER * H){
	UDM_FREE(H->name);
	UDM_FREE(H->value);
	return;
}

void UdmHeaderListFree(UDM_HTTPHEADERLIST * Lst){
	size_t i;
	
	for(i=0;i<Lst->nheaders;i++){
		UdmHeaderFree(&Lst->Headers[i]);
	}
	UDM_FREE(Lst->Headers);
	bzero(Lst,sizeof(*Lst));
	return;
}

void UdmHeaderListAdd(UDM_HTTPHEADERLIST * Lst,UDM_HTTPHEADER * S){
	
	Lst->Headers=(UDM_HTTPHEADER*)realloc(Lst->Headers,(Lst->nheaders+1)*sizeof(*Lst->Headers));
	bzero(&Lst->Headers[Lst->nheaders],sizeof(*Lst->Headers));
	Lst->Headers[Lst->nheaders].name=strdup(S->name);
	Lst->Headers[Lst->nheaders].value=strdup(S->value);
	Lst->nheaders++;
	return;
}

UDM_HTTPHEADER * UdmHeaderListFind(UDM_HTTPHEADERLIST * L,const char * name){
	size_t i;
	
	for(i=0;i<L->nheaders;i++)
		if(!strcasecmp(L->Headers[i].name,name))
			return(&L->Headers[i]);
	return NULL;
}
